# Biography
Feature rich biography plug-in for [foobar2000](https://www.foobar2000.org)

### FEATURES
- Downloads and displays artist photos, biographies and reviews from last.fm, allmusic and wikipedia
     - main artist, similar artists, contributing artists, performers and composers etc
     - main album, top albums, tracks and classical compositions
     - history
- Lyrics: synced and unsynced
- Textreader
- Item properties
- Nowplaying display
- Layout presets: top, left, right, bottom and overlay. Fully customisable with freestyle layouts
- Themes: user interface, dark, blend, light and random
- Custom colours and fonts
- Filmstrip: top, left, right, bottom or hidden
- Image+text, image only or text only
- Drag resizing of image and filmstrip (press Ctrl while panel has focus)
- Custom title format for field remapping and save locations
- And more...

### REQUIREMENTS:
- [foobar2000](https://www.foobar2000.org)
- [Spider Monkey Panel 1.5.2+](https://www.foobar2000.org/components)
- IE9 or later
- [FontAwesome](https://github.com/FortAwesome/Font-Awesome/blob/fa-4/fonts/fontawesome-webfont.ttf?raw=true)
- Segoe UI Symbol
    - should be present on most windows systems
    - if you're on win7 and symbols don't render properly you can download an updated version that includes newer symbols [here](https://www.stephanpringle.com/corrupted-segoe-ui-symbol-font/)

### INSTALLATION
Install as a package as follows.

New install or update:
1) Add a spider monkey panel to foobar2000 if required
2) Close any instances of windows explorer using foobar2000 folders or subfolders
3) Right click the spider monkey panel while pressing the windows key + shift
4) Choose configure panel
5) On the script tab ensure package is selected
6) Open package manager if it doesn't open automatically
7) Import the package

### SUPPORT
The official discussion thread for Biography is located at [HydrogenAudio](https://hydrogenaud.io/index.php?topic=112914.0) and that's a great place
to go for questions and other support issues.

## Screenshots
 
### Top layout with dark theme
<img src="https://user-images.githubusercontent.com/35600752/156555951-b6bd4732-c25f-43f0-9b32-e10cbeef8ebd.png" width=67%>

### Lyrics display with overlay layout and dark theme
![Wolf Alice lyrics](https://user-images.githubusercontent.com/35600752/155892617-06bcf059-bfd9-43dd-bc61-8a06e2da81df.png)
See textreader & lyrics tab help for set-up tips

### Various layouts
![Various layouts](https://user-images.githubusercontent.com/35600752/171164742-bd0610dd-6f0e-4d26-834e-c3d944857a3a.png)

### Amalgamated sources
![Amalgamate sources ](https://user-images.githubusercontent.com/35600752/171165042-efc9a884-91fc-4aa4-bd74-1fdce81d91d1.png)

### Item properties
Enable on textreader & lyrics tab.
<br><br>
Standard grouping
![item_properties](https://user-images.githubusercontent.com/35600752/179354318-3479fee8-54fe-46ff-ae06-d405eebbc553.png)

Alternative grouping
![item_properties_alternative_grouping](https://user-images.githubusercontent.com/35600752/179354332-31ef0545-4834-4837-bcbc-a86f912181e6.png)
